#!/usr/bin/env python
# This is fht3, 2011 (c) Romain Mueller
# Based on a highly non-efficient version written by Julian and Julian.
import sys, subprocess, re, glob
from hashlib import md5
from os import remove, system
from os.path import exists

# read .tex file
f = open(sys.argv[1]+'.tex').read()
p = re.compile(r'\\begin{fmffile}{(.*?)}.*?\\end{fmffile}', re.DOTALL)

# copy header of the file
m = re.search(r'(.*?\\begin{document}).*?\\end{document}', f, re.DOTALL);
header = m.group(1)

# find first fmffile
m = p.search(f)
# while we find something
while m != None:
  # get things
  code = m.group(0)
  name = m.group(1)
  print name,
  # find next fmffile
  m = p.search(f, m.end())
  # hash!
  h = md5(code).digest()
  # if file exists
  if exists(name+'.md5'):
    # compare digests
    if open(name+'.md5', 'rb').read() == h:
      # don't update !
      print '... nothing to do'
      continue
 
  # update ...
  # remove files
  print '... updating'
  for i in glob.glob(name+'*'): remove(i)
  # create new dummy file with the graph (could be optimized...)
  dummy = header+code+'\\end{document}'
  open('fht_dummy.tex', 'w').write(dummy)
  # run pdflatex & metafont
  print '... pdflatex'
  system('pdflatex fht_dummy > fht_dummy.tmp')
  print '... mf'
  system('mf \'\\mode=localfont; input '+name+'.mf;\' > fht_dummy.tmp 2>&1')
  # rm temp files
  system('rm fht_dummy*')
  # write new md5
  print '... md5'
  g = open(name+'.md5', 'wb')
  g.write(h)
  
  print '... updated'

# finally compile
print 'Compiling',
system('bibtex '+sys.argv[1])
system('makeindex '+sys.argv[1]+'.idx > fht.log 2>&1')
system('pdflatex '+sys.argv[1]+' > fht.log 2>&1')
print '... done'
